Imports Inventor
Imports System.Runtime.InteropServices
Imports Microsoft.Win32

Namespace AlsPDFSpeichern
    <ProgIdAttribute("AlsPDFSpeichern.StandardAddInServer"), _
    GuidAttribute("4334d879-7fc8-409d-8fce-4f4a030bc245")> _
    Public Class StandardAddInServer
        Implements Inventor.ApplicationAddInServer

        ' Inventor application object.
        Private myInventor As Inventor.Application
        Private WithEvents m_appEvents As Inventor.ApplicationEvents


#Region "ApplicationAddInServer Members"

        Public Sub Activate(ByVal addInSiteObject As Inventor.ApplicationAddInSite, ByVal firstTime As Boolean) Implements Inventor.ApplicationAddInServer.Activate

            ' This method is called by Inventor when it loads the AddIn.
            ' The AddInSiteObject provides access to the Inventor Application object.
            ' The FirstTime flag indicates if the AddIn is loaded for the first time.

            ' Initialize AddIn members.
            myInventor = addInSiteObject.Application
            m_appEvents = myInventor.ApplicationEvents

            ' TODO:  Add ApplicationAddInServer.Activate implementation.
            ' e.g. event initialization, command creation etc.

        End Sub

        Public Sub Deactivate() Implements Inventor.ApplicationAddInServer.Deactivate

            ' This method is called by Inventor when the AddIn is unloaded.
            ' The AddIn will be unloaded either manually by the user or
            ' when the Inventor session is terminated.

            ' TODO:  Add ApplicationAddInServer.Deactivate implementation

            ' Release objects.
            Marshal.ReleaseComObject(myInventor)
            myInventor = Nothing

            Marshal.ReleaseComObject(m_appEvents)
            m_appEvents = Nothing


            System.GC.WaitForPendingFinalizers()
            System.GC.Collect()

        End Sub

        Public ReadOnly Property Automation() As Object Implements Inventor.ApplicationAddInServer.Automation

            ' This property is provided to allow the AddIn to expose an API 
            ' of its own to other programs. Typically, this  would be done by
            ' implementing the AddIn's API interface in a class and returning 
            ' that class object through this property.

            Get
                Return Nothing
            End Get

        End Property

        Public Sub ExecuteCommand(ByVal commandID As Integer) Implements Inventor.ApplicationAddInServer.ExecuteCommand

            ' Note:this method is now obsolete, you should use the 
            ' ControlDefinition functionality for implementing commands.

        End Sub

        Private Sub m_appEvents_OnSaveDocument( _
               ByVal DocumentObject As Inventor._Document, _
               ByVal BeforeOrAfter As Inventor.EventTimingEnum, _
               ByVal Context As Inventor.NameValueMap, _
               ByRef HandlingCode As Inventor.HandlingCodeEnum) _
                                  Handles m_appEvents.OnSaveDocument

            MsgBox("Test")
            ' Get the PDF translator Add-In.
            Dim PDFAddIn As TranslatorAddIn
            PDFAddIn = myInventor.ApplicationAddIns.ItemById("{0AC6FD96-2F4D-42CE-8BE0-8AEA580399E4}")

            'Set a reference to the active document (the document to be published).
            Dim oDocument As Document
            oDocument = myInventor.ActiveDocument

            Dim oContext As TranslationContext
            oContext = myInventor.TransientObjects.CreateTranslationContext
            oContext.Type = IOMechanismEnum.kFileBrowseIOMechanism

            ' Create a NameValueMap object
            Dim oOptions As NameValueMap
            oOptions = myInventor.TransientObjects.CreateNameValueMap

            ' Create a DataMedium object
            Dim oDataMedium As DataMedium
            oDataMedium = myInventor.TransientObjects.CreateDataMedium

            ' Check whether the translator has 'SaveCopyAs' options
            If PDFAddIn.HasSaveCopyAsOptions(oDocument, oContext, oOptions) Then

                ' Options for drawings...

                oOptions.Value("All_Color_AS_Black") = 0

                'oOptions.Value("Remove_Line_Weights") = 0
                'oOptions.Value("Vector_Resolution") = 400
                oOptions.Value("Sheet_Range") = PrintRangeEnum.kPrintAllSheets '<------------ alle Bltter ins PDF drucken
                'oOptions.Value("Custom_Begin_Sheet") = 2
                'oOptions.Value("Custom_End_Sheet") = 4

            End If

            'Set the destination file name
            oDataMedium.FileName = Replace(oDocument.FullFileName, Right(oDocument.FullFileName, 3), "pdf")

            'Publish document.
            Call PDFAddIn.SaveCopyAs(oDocument, oContext, oOptions, oDataMedium)
        End Sub

#End Region

    End Class

End Namespace

